------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Scroll_Areas;
with Qt4.Brushes;
limited with Qt4.Graphics_Items;
limited with Qt4.Graphics_Scenes;
with Qt4.Matrices;
with Qt4.Painter_Paths;
with Qt4.Painters;
with Qt4.Point_Fs;
with Qt4.Points;
with Qt4.Polygon_Fs;
with Qt4.Polygons;
with Qt4.Rect_Fs;
with Qt4.Rects;
with Qt4_Generic_Flags;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Graphics_Views is

   type Graphics_View_Cache_Mode_Flag is
    (Cache_None,
     Cache_Background);
   pragma Convention (C, Graphics_View_Cache_Mode_Flag);
   for Graphics_View_Cache_Mode_Flag'Size use Interfaces.C.int'Size;

   type Graphics_View_Drag_Mode is
    (No_Drag,
     Scroll_Hand_Drag,
     Rubber_Band_Drag);
   pragma Convention (C, Graphics_View_Drag_Mode);

   type Graphics_View_Viewport_Anchor is
    (No_Anchor,
     Anchor_View_Center,
     Anchor_Under_Mouse);
   pragma Convention (C, Graphics_View_Viewport_Anchor);

   type Graphics_View_Viewport_Update_Mode is
    (Full_Viewport_Update,
     Minimal_Viewport_Update,
     Smart_Viewport_Update,
     No_Viewport_Update,
     Bounding_Rect_Viewport_Update);
   pragma Convention (C, Graphics_View_Viewport_Update_Mode);

   type Q_Graphics_View is limited interface
     and Qt4.Abstract_Scroll_Areas.Q_Abstract_Scroll_Area;

   type Q_Graphics_View_Access is
     access all Q_Graphics_View'Class;
   for Q_Graphics_View_Access'Storage_Size use 0;

   type Q_Graphics_View_Pointer is tagged;

   function Background_Brush
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Brushes.Q_Brush;

   procedure Center_On
    (Self : not null access Q_Graphics_View'Class;
     Pos : Qt4.Point_Fs.Q_Point_F);

   procedure Center_On
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real);

   procedure Center_On
    (Self : not null access Q_Graphics_View'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class);

   function Drag_Mode
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Drag_Mode;

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50);

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50);

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_View'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50);

   procedure Fit_In_View
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode
       := Qt4.Ignore_Aspect_Ratio);

   procedure Fit_In_View
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode
       := Qt4.Ignore_Aspect_Ratio);

   procedure Fit_In_View
    (Self : not null access Q_Graphics_View'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode
       := Qt4.Ignore_Aspect_Ratio);

   function Foreground_Brush
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Brushes.Q_Brush;

   function Is_Interactive
    (Self : not null access constant Q_Graphics_View'Class)
       return Standard.Boolean;

   function Item_At
    (Self : not null access constant Q_Graphics_View'Class;
     Pos : Qt4.Points.Q_Point)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;

   function Item_At
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Points.Q_Point;

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygons.Q_Polygon;

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygons.Q_Polygon;

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path;

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Points.Q_Point;

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygons.Q_Polygon;

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Point : Qt4.Points.Q_Point)
       return Qt4.Point_Fs.Q_Point_F;

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Rect : Qt4.Rects.Q_Rect)
       return Qt4.Polygon_Fs.Q_Polygon_F;

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Polygon : Qt4.Polygons.Q_Polygon)
       return Qt4.Polygon_Fs.Q_Polygon_F;

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path;

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return Qt4.Point_Fs.Q_Point_F;

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
       return Qt4.Polygon_Fs.Q_Polygon_F;

   function Matrix
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Matrices.Q_Matrix;

   procedure Reset_Cached_Content
    (Self : not null access Q_Graphics_View'Class);

   procedure Reset_Matrix
    (Self : not null access Q_Graphics_View'Class);

   function Resize_Anchor
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Anchor;

   procedure Rotate
    (Self : not null access Q_Graphics_View'Class;
     Angle : Qt4.Q_Real);

   procedure Scale
    (Self : not null access Q_Graphics_View'Class;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real);

   function Scene
    (Self : not null access constant Q_Graphics_View'Class)
       return not null access Qt4.Graphics_Scenes.Q_Graphics_Scene'Class;

   function Scene_Rect
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Rect_Fs.Q_Rect_F;

   procedure Set_Background_Brush
    (Self : not null access Q_Graphics_View'Class;
     Brush : Qt4.Brushes.Q_Brush);

   procedure Set_Drag_Mode
    (Self : not null access Q_Graphics_View'Class;
     Mode : Qt4.Graphics_Views.Graphics_View_Drag_Mode);

   procedure Set_Foreground_Brush
    (Self : not null access Q_Graphics_View'Class;
     Brush : Qt4.Brushes.Q_Brush);

   procedure Set_Interactive
    (Self : not null access Q_Graphics_View'Class;
     Allowed : Standard.Boolean);

   procedure Set_Matrix
    (Self : not null access Q_Graphics_View'Class;
     Matrix : Qt4.Matrices.Q_Matrix;
     Combine : Standard.Boolean
       := False);

   procedure Set_Resize_Anchor
    (Self : not null access Q_Graphics_View'Class;
     Anchor : Qt4.Graphics_Views.Graphics_View_Viewport_Anchor);

   procedure Set_Scene
    (Self : not null access Q_Graphics_View'Class;
     Scene : not null access Qt4.Graphics_Scenes.Q_Graphics_Scene'Class);

   procedure Set_Scene_Rect
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F);

   procedure Set_Scene_Rect
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real);

   procedure Set_Transformation_Anchor
    (Self : not null access Q_Graphics_View'Class;
     Anchor : Qt4.Graphics_Views.Graphics_View_Viewport_Anchor);

   procedure Set_Viewport_Update_Mode
    (Self : not null access Q_Graphics_View'Class;
     Mode : Qt4.Graphics_Views.Graphics_View_Viewport_Update_Mode);

   procedure Shear
    (Self : not null access Q_Graphics_View'Class;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real);

   function Transformation_Anchor
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Anchor;

   procedure Translate
    (Self : not null access Q_Graphics_View'Class;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real);

   function Viewport_Update_Mode
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Update_Mode;

   procedure Update_Scene_Rect
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F);

   package Cache_Mode_Flag_Flags is
     new Qt4_Generic_Flags (Graphics_View_Cache_Mode_Flag);

   type Cache_Mode_Flags is new Cache_Mode_Flag_Flags.Flags;

   procedure Set_Cache_Mode
    (Self : not null access Q_Graphics_View'Class;
     Mode : Cache_Mode_Flags);

   procedure Set_Render_Hint
    (Self    : not null access Q_Graphics_View'Class;
     Hint    : Qt4.Painters.Render_Hint;
     Enabled : Boolean := True);

   package Q_Graphics_View_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Graphics_View, Q_Graphics_View_Access);

   type Q_Graphics_View_Pointer is
     new Q_Graphics_View_Pointers.Q_Pointer with null record;

end Qt4.Graphics_Views;
